package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Activator;
import com.vendor.burn.Messages;
import com.vendor.burn.model.FlashType;
import com.vendor.burn.model.PlatformType;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.devices.IBootBurner;
import com.vendor.burn.model.devices.IDeviceSetting;
import com.vendor.burn.model.devices.IUIAdapter;
import com.vendor.burn.model.devices.burners.AbstractBurner;
import com.vendor.burn.model.devices.unknown.UnknownDevice;
import com.vendor.burn.model.dqInfo;
import com.vendor.burn.model.phyInfo;
import com.vendor.burn.ui.BurnComposite;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.events.IHyperlinkListener;
import org.eclipse.ui.forms.widgets.ImageHyperlink;

public class DdrCheckComposite extends BurnComposite {
  public static final String ID = com.vendor.burn.ui.burners.DdrCheckComposite.class.getName();
  
  protected static Image greenLight = Activator.getImage("icons//green_light.png");
  
  protected static Image redLight = Activator.getImage("icons/red_light.png");
  
  protected static Image grayLight = Activator.getImage("icons/white_light.png");
  
  protected static List<ImageHyperlink> phylblList = new ArrayList<>();
  
  protected Button burnButton;
  
  protected Text programmerFileText;
  
  protected Button programmerFileBrowseButton;
  
  private Button browseButton;
  
  private Combo flashTypeCombo;
  
  private Text fileText;
  
  private static ScrolledComposite scrolledComposite;
  
  private static Composite parent;
  
  private static String initLabelName = "init :";
  
  private static String acOrDqsLabelName = "AC or CLK or DQS:";
  
  private static String zQLabelName = "ZQ :";
  
  private static String dQLabelName = "DQ :";
  
  private static String PASS = " Pass";
  
  private static String FAIL = " Fail";
  
  private static Color green;
  
  private static Color red;
  
  public DdrCheckComposite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
    green = new Color((Device)parent.getDisplay(), 0, 255, 0);
    red = new Color((Device)parent.getDisplay(), 255, 0, 0);
  }
  
  public IBootBurner getBurner() {
    if (super.getBurner() instanceof IBootBurner)
      return (IBootBurner)super.getBurner(); 
    return null;
  }
  
  public static void createPartControl(List<phyInfo> phyInfoList) {
    if (scrolledComposite != null && !scrolledComposite.isDisposed())
      scrolledComposite.dispose(); 
    scrolledComposite = new ScrolledComposite(parent, 2560);
    GridData scrollableLayoutData = new GridData(1808);
    scrollableLayoutData.horizontalSpan = 4;
    scrolledComposite.setLayoutData(scrollableLayoutData);
    scrolledComposite.setExpandHorizontal(true);
    scrolledComposite.setExpandVertical(true);
    scrolledComposite.setMinWidth(300);
    scrolledComposite.setMinHeight(900);
    scrolledComposite.setAlwaysShowScrollBars(true);
    Composite composite = new Composite((Composite)scrolledComposite, 0);
    composite.setLayout((Layout)new GridLayout(3, false));
    GridData gd = new GridData(1808);
    gd.heightHint = 1;
    composite.setLayoutData(gd);
    scrolledComposite.setContent((Control)composite);
    GridData layoutData1 = new GridData(1808);
    Composite compositePhy0 = new Composite(composite, 2048);
    compositePhy0.setLayout((Layout)new GridLayout(3, false));
    compositePhy0.setLayoutData(layoutData1);
    Composite compositePhy1 = new Composite(composite, 2048);
    compositePhy1.setLayout((Layout)new GridLayout(3, false));
    compositePhy1.setLayoutData(layoutData1);
    ImageHyperlink link = new ImageHyperlink(compositePhy0, 0);
    link.setUnderlined(true);
    link.setText("DDR0");
    setLinkFontSize(link, compositePhy0);
    link.setImage(grayLight);
    ImageHyperlink link1 = new ImageHyperlink(compositePhy1, 0);
    link1.setUnderlined(true);
    link1.setText("DDR1");
    setLinkFontSize(link1, compositePhy1);
    link1.setImage(grayLight);
    addHyperlinkListenerToView(link, "");
    addHyperlinkListenerToView(link1, "");
    changeLightStatu(phyInfoList, link1, link, compositePhy0, compositePhy1);
    parent.layout();
  }
  
  private static void changeLightColor(ImageHyperlink link, ImageHyperlink link1, phyInfo info, int i) {
    if (info.getStatu().toString() == "GREEN" && i == 0)
      link.setImage(greenLight); 
    if (info.getStatu().toString() == "RED" && i == 0)
      link.setImage(redLight); 
    if (info.getStatu().toString() == "GREEN" && i == 1)
      link1.setImage(greenLight); 
    if (info.getStatu().toString() == "RED" && i == 1)
      link1.setImage(redLight); 
  }
  
  private static void changeLightStatu(List<phyInfo> phyInfoList, ImageHyperlink link1, ImageHyperlink link, Composite compositePhy0, Composite compositePhy1) {
    if (phyInfoList != null)
      for (int i = 0; i < phyInfoList.size(); i++) {
        phyInfo info = phyInfoList.get(i);
        changeLightColor(link, link1, info, i);
        Label initLabel = null;
        Label aCorDQSLabel = null;
        Label zQLabel = null;
        Label dQLabel = null;
        if (i == 0) {
          initLabel = new Label(compositePhy0, 0);
          aCorDQSLabel = new Label(compositePhy0, 0);
          zQLabel = new Label(compositePhy0, 0);
          dQLabel = new Label(compositePhy0, 0);
        } else {
          initLabel = new Label(compositePhy1, 0);
          aCorDQSLabel = new Label(compositePhy1, 0);
          zQLabel = new Label(compositePhy1, 0);
          dQLabel = new Label(compositePhy1, 0);
        } 
        setLabelStyle(initLabel, aCorDQSLabel, zQLabel, dQLabel, info, i, compositePhy0, compositePhy1);
      }  
  }
  
  private static void setLabelStyle(Label initLabel, Label aCorDQSLabel, Label zQLabel, Label dQLabel, phyInfo info, int i, Composite compositePhy0, Composite compositePhy1) {
    List<dqInfo> dqInfoList = info.getDqInfoList();
    Composite com = null;
    if (dqInfoList != null) {
      if (i == 0) {
        com = compositePhy0;
      } else {
        com = compositePhy1;
      } 
      Composite dQComposite = new Composite(com, 0);
      dQComposite.setLayout((Layout)new GridLayout(3, true));
      GridData gd = new GridData(1808);
      dQComposite.setLayoutData(gd);
      Label singleDQLabel = null;
      for (int j = 0; j < dqInfoList.size(); j++) {
        singleDQLabel = new Label(dQComposite, 0);
        GridData grid = new GridData(0, 0, true, true, 3, 1);
        singleDQLabel.setLayoutData(grid);
        if (((dqInfo)dqInfoList.get(j)).getStatu() == dqInfo.STATU.GREEN) {
          singleDQLabel.setText(((dqInfo)dqInfoList.get(j)).getName() + ((dqInfo)dqInfoList.get(j)).getName());
          singleDQLabel.setForeground(green);
        } else {
          singleDQLabel.setText(((dqInfo)dqInfoList.get(j)).getName() + ((dqInfo)dqInfoList.get(j)).getName());
          singleDQLabel.setForeground(red);
        } 
      } 
    } 
    initLabel.setText(initLabelName + initLabelName);
    initLabel.setLayoutData(new GridData(4, 4, true, true, 3, 1));
    setLabelFontSize(initLabel, com);
    aCorDQSLabel.setText(acOrDqsLabelName + acOrDqsLabelName);
    aCorDQSLabel.setLayoutData(new GridData(4, 4, true, true, 3, 1));
    setLabelFontSize(aCorDQSLabel, com);
    zQLabel.setText(zQLabelName + zQLabelName);
    zQLabel.setLayoutData(new GridData(4, 4, true, true, 3, 1));
    setLabelFontSize(zQLabel, com);
    dQLabel.setText(dQLabelName + dQLabelName);
    dQLabel.setLayoutData(new GridData(4, 4, true, true, 3, 1));
    setLabelForegroundColor(initLabel, aCorDQSLabel, zQLabel, dQLabel, info);
    setLabelFontSize(dQLabel, com);
    ArrayList<Label> dQLabelList = new ArrayList<>();
    setDqLabelForegroundColor(dQLabel, dQLabelList, info);
  }
  
  private static void setDqLabelForegroundColor(Label dQLabel, ArrayList<Label> dQLabelList, phyInfo info) {
    if (info.getInit() == null || info.getInit().isEmpty())
      return; 
    String dq = info.getDq();
    if (dq == null || dq.isEmpty())
      return; 
    if (dq.toLowerCase().equals("pass")) {
      for (int i = 0; i < dQLabelList.size(); i++)
        ((Label)dQLabelList.get(i)).setForeground(green); 
    } else {
      for (int i = 0; i < dQLabelList.size(); i++)
        ((Label)dQLabelList.get(i)).setForeground(red); 
    } 
  }
  
  private static void setLinkFontSize(ImageHyperlink link, Composite com) {
    link.setFont(new Font((Device)com.getDisplay(), Messages.Font_Style, 14, 1));
  }
  
  private static void setLabelFontSize(Label initLabel, Composite com) {
    if (com != null)
      initLabel.setFont(new Font((Device)com.getDisplay(), Messages.Font_Style, 14, 1)); 
  }
  
  private static void setLabelForegroundColor(Label initLabel, Label aCorDQSLabel, Label zQLabel, Label dQLabel, phyInfo phyinfo) {
    if (phyinfo.getInit() == null || phyinfo.getInit().isEmpty())
      return; 
    boolean initSuccess = updateInitSuccess(phyinfo);
    if (dQLabel == null || initLabel == null || aCorDQSLabel == null || zQLabel == null)
      return; 
    if (initSuccess) {
      initLabel.setForeground(green);
    } else {
      initLabel.setForeground(red);
    } 
    String dq = phyinfo.getDq();
    if (dq == null || dq.isEmpty())
      return; 
    if (dq.toLowerCase().equals("pass")) {
      dQLabel.setForeground(green);
    } else {
      dQLabel.setForeground(red);
    } 
    String acorDqs = phyinfo.getAcordqs();
    if (acorDqs.toLowerCase().equals("/")) {
      aCorDQSLabel.setForeground(green);
    } else {
      aCorDQSLabel.setForeground(red);
    } 
    String zq = phyinfo.getZq();
    if (zq.toLowerCase().equals("pass")) {
      zQLabel.setForeground(green);
    } else {
      zQLabel.setForeground(red);
    } 
  }
  
  private static boolean updateInitSuccess(phyInfo phyinfo) {
    boolean initSuccess = true;
    char[] initArray = null;
    if (phyinfo.getInit().startsWith("0x")) {
      initArray = phyinfo.getInit().substring(2).toCharArray();
    } else {
      initArray = phyinfo.getInit().toCharArray();
    } 
    for (int i = 0; i < initArray.length; i++) {
      if (initArray[i] != '0') {
        initSuccess = false;
        break;
      } 
    } 
    return initSuccess;
  }
  
  protected Button createButton(Composite buttonComp, String label) {
    Button button = new Button(buttonComp, 0);
    button.setText(label);
    GridData layoutData = new GridData(576);
    layoutData.minimumWidth = 100;
    button.setLayoutData(layoutData);
    return button;
  }
  
  protected List<Button> createButtons(Composite buttonComp) {
    List<Button> buttons = new ArrayList<>();
    fillButtons(buttonComp, buttons);
    return buttons;
  }
  
  protected void createButtonsControl(Composite parent) {
    Composite buttonComp = new Composite(parent, 0);
    GridData layoutData = new GridData(776);
    layoutData.horizontalSpan = 3;
    buttonComp.setLayoutData(layoutData);
    List<Button> buttons = createButtons(buttonComp);
    buttonComp.setLayout((Layout)new GridLayout(buttons.size(), true));
  }
  
  protected void createContents(Composite parent) {
    com.vendor.burn.ui.burners.DdrCheckComposite.parent = parent;
    createFlashTypeEditor(parent, null);
    createFileEditor(parent);
    IDeviceSetting setting = getBurner().getBurnContext().getDeviceSetting();
    if (setting instanceof UnknownDevice && (
      getBurner().getBurnContext().getPlatformType() == PlatformType.CA || ((UnknownDevice)setting)
      .isSupportBurnByLibBootrom()))
      createProgrammerFileText(parent); 
    createButtonsControl(parent);
    initData();
  }
  
  protected void initData() {
    IBootBurner burner = getBurner();
    String[] flashNames = burner.getBurnContext().getDeviceSetting().getFlashSetting().getFlashNames((IBurner)burner);
    this.flashTypeCombo.setItems(new String[] { flashNames[2] });
    this.flashTypeCombo.select(0);
  }
  
  protected void createFileEditor(Composite parent) {
    Label label = new Label(parent, 0);
    label.setText(LABEL_FILE);
    this.fileText = new Text(parent, 2048);
    GridData layoutData = new GridData(768);
    layoutData.horizontalSpan = 2;
    this.fileText.setLayoutData(layoutData);
    this.fileText.addListener(24, (Listener)new Object(this));
    this.fileText.setEnabled(false);
    this.browseButton = new Button(parent, 0);
    this.browseButton.setText(LABEL_BROWSE);
    this.browseButton.addListener(13, (Listener)new Object(this));
  }
  
  protected void updateFileEditor(Composite parent, String filePath) {
    this.fileText.setText(String.valueOf(filePath));
  }
  
  protected void createFlashTypeEditor(Composite parent, FlashType flashType) {
    Label label = new Label(parent, 0);
    label.setText(LABEL_FALSH_TYPE);
    this.flashTypeCombo = new Combo(parent, 8);
    GridData layoutData = new GridData(544);
    layoutData.horizontalSpan = 3;
    this.flashTypeCombo.setLayoutData(layoutData);
    this.flashTypeCombo.addListener(13, (Listener)new Object(this));
  }
  
  protected void handleFlashTypeChanged() {
    int index = this.flashTypeCombo.getSelectionIndex();
    if (index == -1)
      index = 0; 
    IBootBurner burner = getBurner();
    FlashType flashType = burner.getBurnContext().getDeviceSetting().getFlashSetting().findFlashType((IBurner)burner, "ddr");
    burner.setFlashType(flashType);
  }
  
  protected void updateFlashType(Composite parent, FlashType flashType) {
    for (int i = 0; i < this.flashTypeCombo.getItemCount(); i++) {
      String flashName = this.flashTypeCombo.getItem(i);
      if (flashName.equalsIgnoreCase("spi nand/nand")) {
        flashName = FlashType.nand.name();
      } else if (flashName.equalsIgnoreCase("spi nor")) {
        flashName = FlashType.spi.name();
      } 
      if (flashType.name().equalsIgnoreCase(flashName))
        this.flashTypeCombo.select(i); 
    } 
    handleFlashTypeChanged();
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(4, false);
  }
  
  protected void disableUI() {
    IUIAdapter adapter = getUIAdapter();
    adapter.disableReloadButton();
    adapter.disableSerialSelection();
    if (isDisposed())
      return; 
    if (this.burnButton != null && !this.burnButton.isDisposed())
      this.burnButton.setEnabled(false); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(false); 
  }
  
  protected void enableButtons() {
    if (this.burnButton != null && !this.burnButton.isDisposed())
      this.burnButton.setEnabled(true); 
  }
  
  protected void enableUI() {
    IUIAdapter adapter = getUIAdapter();
    adapter.enableReloadButton();
    adapter.enableSerialSelection();
    if (isDisposed())
      return; 
    enableButtons();
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(true); 
  }
  
  protected void fillButtons(Composite buttonComp, List<Button> buttons) {
    this.burnButton = createButton(buttonComp, BurnComposite.LABEL_DDRCHECK);
    IBootBurner burner = getBurner();
    FlashType flashType = burner.getBurnContext().getDeviceSetting().getFlashSetting().findFlashType((IBurner)burner, "ddr");
    burner.setFlashType(flashType);
    this.burnButton.addListener(13, (Listener)new Object(this));
    buttons.add(this.burnButton);
  }
  
  protected void handleBrwoseFileCA() {
    FileDialog dialog = new FileDialog(getShell(), 4096);
    String text = this.programmerFileText.getText();
    if (!text.equals(""))
      dialog.setFileName(text); 
    String filePath = dialog.open();
    if (filePath != null) {
      this.programmerFileText.setText(filePath);
      File bootFile = new File(filePath);
      if (bootFile.exists())
        ((AbstractBurner)getBurner()).setProgrammerFile(filePath); 
    } 
  }
  
  protected void createProgrammerFileText(Composite parent) {
    Label programmerFileLabel = new Label(parent, 0);
    programmerFileLabel.setText(Messages.FastbootComposite_LABEL_PROGRAMER_FILE);
    this.programmerFileText = new Text(parent, 2048);
    GridData layoutData = new GridData(768);
    layoutData.horizontalSpan = 2;
    this.programmerFileText.setEnabled(false);
    this.programmerFileText.setLayoutData(layoutData);
    this.programmerFileBrowseButton = new Button(parent, 0);
    this.programmerFileBrowseButton.setLayoutData(new GridData());
    this.programmerFileBrowseButton.setText(LABEL_BROWSE);
    this.programmerFileBrowseButton.addListener(13, (Listener)new Object(this));
  }
  
  private static void addHyperlinkListenerToView(ImageHyperlink imageHyperlink, String info) {
    imageHyperlink.addHyperlinkListener((IHyperlinkListener)new Object(info, imageHyperlink));
  }
}
